# = RubyPlus
#
# Author::  Dice <rubyist@morphball.net>
# Version:: 0.1
# Licence:: Public domain (unlike other files)
# URL::     http://ruby.morphball.net/rubyplus.html
# 
# *RubyPlus* is an assortment of small extension libraries.


require 'rubyplus/boolattr'
require 'rubyplus/in'
require 'rubyplus/pathname'
require 'rubyplus/total'

if defined?(Spec) then
	describe 'rubyplus/boolattr' do
		it 'can define bool-attributes' do
			mod = Module.new
			mod.module_eval{
				bool_attr_reader :r1
				bool_attr :r2, false
				bool_attr_accessor :a1
				bool_attr :a2, true
			}

			[:r1, :r1?, :r2, :r2?, :a1, :a1?, :a1=, :a2, :a2?, :a2=].each do |name|
				mod.should be_method_defined(name)
			end
			
			[:r1=, :r2=].each do |name|
				mod.should_not be_method_defined(name)
			end
		end
	end
	
	describe 'rubyplus/in' do
		it 'should operate without error' do
			3.in?(3..5)
		end
	end
	
	describe 'rubyplus/pathname' do
		it 'can make Pathname' do
			Path('/foo/bar').should be_kind_of(Pathname)
			Pathname('/foo/bar').should be_kind_of(Pathname)
			'/foo/bar'.to_pathname.should be_kind_of(Pathname)
		end
	end



	describe 'rubyplus/total' do
		it 'can calculate number' do
			[1, 2, 3, 4].total.should == 10
			[1.0, 2.5, 4.5].total.should == 8.0
		end
	end
end